require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/meth/steps', type: :request do
  let(:valid_attributes) { FactoryBot.attributes_for(:meth_step, methodology_id: methodology.id, step_role_id: step_role.id) }
  let(:invalid_attributes) { FactoryBot.attributes_for(:meth_step_tool, name: '', methodology_id: methodology.id, step_role_id: step_role.id) }

  let(:user) { FactoryBot.create(:user) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:step_role) { FactoryBot.create(:meth_step_role) }

  before :each do
    user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
    user.save!
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Meth::Step.create! valid_attributes
      get meth_steps_url
      expect(response).to be_successful
    end
  end

  describe 'GET /show' do
    it 'renders a successful response' do
      meth_step = Meth::Step.create! valid_attributes
      get meth_step_url(meth_step)
      expect(response).to be_successful
    end
  end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_meth_step_url(methodology: methodology.id), xhr: true
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      meth_step = Meth::Step.create! valid_attributes
      get edit_meth_step_url(meth_step)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Meth::Step' do
        expect {
          post meth_steps_url, params: { meth_step: valid_attributes }
        }.to change(Meth::Step, :count).by(1)
      end

      it 'redirects to the created meth_step' do
        post meth_steps_url, params: { meth_step: valid_attributes }
        expect(response).to redirect_to(edit_meth_methodology_path(id: methodology.id, step: @controller.instance_variable_get(:@step)))
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Meth::Step' do
        expect {
          post meth_steps_url, params: { meth_step: invalid_attributes }
        }.to change(Meth::Step, :count).by(0)
      end

      it 'renders a redirect response' do
        post meth_steps_url, params: { meth_step: invalid_attributes }
        expect(response).to redirect_to(edit_meth_methodology_path(methodology))
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { {name: 'le nouveau nom'} }

      it 'updates the requested meth_step' do
        meth_step = Meth::Step.create! valid_attributes
        patch meth_step_url(meth_step), params: { meth_step: new_attributes }
        meth_step.reload
        expect(meth_step.name).to eq 'le nouveau nom'
      end

      it 'redirects to the meth_step' do
        meth_step = Meth::Step.create! valid_attributes
        patch meth_step_url(meth_step), params: { meth_step: new_attributes }
        meth_step.reload
        expect(response).to redirect_to(meth_step_url(meth_step))
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        meth_step = Meth::Step.create! valid_attributes
        patch meth_step_url(meth_step), params: { meth_step: invalid_attributes }
        expect(meth_step.name).to eq valid_attributes[:name]
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested meth_step' do
      meth_step = Meth::Step.create! valid_attributes
      expect {
        delete meth_step_url(meth_step)
      }.to change(Meth::Step, :count).by(-1)
    end

    it 'redirects to the meth_steps list' do
      meth_step = Meth::Step.create! valid_attributes
      delete meth_step_url(meth_step)
      expect(response).to redirect_to(edit_meth_methodology_path(methodology))
    end
  end

  describe 'DELETE /step_del_tool' do
    it 'del a tool from step_tool' do
      meth_step = Meth::Step.create! valid_attributes
      step_tool = meth_step.add_tool(FactoryBot.create(:meth_tool, :custom_field))
      meth_step.add_tool(FactoryBot.create(:meth_tool, :task))

      expect {
        delete meth_step_del_tool_path(id: meth_step.id, step_tool: step_tool)
      }.to change(Meth::StepTool, :count).by(-1)
      expect(meth_step.tools.count).to eq 1
      expect(response).to redirect_to(edit_meth_methodology_path(id: methodology.id, step: meth_step.id))
    end
  end

  describe 'POST step_add_tool' do
    it 'adds a tool to step_tool' do
      meth_step = Meth::Step.create! valid_attributes
      tool = FactoryBot.create(:meth_tool, :custom_field)

      expect {
        post meth_step_add_tool_path(id: meth_step.id, tool: tool)
      }.to change(Meth::StepTool, :count).by(1)
      expect(meth_step.tools.count).to eq 1
      expect(response).to redirect_to(edit_meth_methodology_path(id: methodology.id, step: meth_step.id))
    end
  end

  describe 'PATCH /step_tool_up' do
    it 'moves up a tool' do
      meth_step = Meth::Step.create! valid_attributes
      step_tool1 = meth_step.add_tool(FactoryBot.create(:meth_tool, :custom_field))
      step_tool2 = meth_step.add_tool(FactoryBot.create(:meth_tool, :task))
      step_tool3 = meth_step.add_tool(FactoryBot.create(:meth_tool, :cause))

      patch meth_step_tool_up_path(id: meth_step.id, step_tool: step_tool1)

      expect(step_tool1.reload.pos).to eq 2
      expect(step_tool2.reload.pos).to eq 1
      expect(step_tool3.reload.pos).to eq 3

      expect(response).to redirect_to(edit_meth_methodology_path(id: methodology.id, step: meth_step.id))
    end
  end

  describe 'PATCH /step_tool_down' do
    it 'moves down a tool' do
      meth_step = Meth::Step.create! valid_attributes
      step_tool1 = meth_step.add_tool(FactoryBot.create(:meth_tool, :custom_field))
      step_tool2 = meth_step.add_tool(FactoryBot.create(:meth_tool, :task))
      step_tool3 = meth_step.add_tool(FactoryBot.create(:meth_tool, :cause))

      patch meth_step_tool_down_path(id: meth_step.id, step_tool: step_tool2)

      expect(step_tool1.reload.pos).to eq 2
      expect(step_tool2.reload.pos).to eq 1
      expect(step_tool3.reload.pos).to eq 3

      expect(response).to redirect_to(edit_meth_methodology_path(id: methodology.id, step: meth_step.id))
    end
  end

  describe 'PATCH /step_up' do
    it 'moves up the step_tool' do
      step1 = FactoryBot.create(:meth_step, name: 'step1', pos: 1, methodology: methodology)
      step2 = FactoryBot.create(:meth_step, name: 'step2', pos: 2, methodology: methodology)
      step3 = FactoryBot.create(:meth_step, name: 'step3', pos: 3, methodology: methodology)

      patch meth_step_up_path(id: step2.id)

      expect(step1.reload.pos).to eq 1
      expect(step2.reload.pos).to eq 3
      expect(step3.reload.pos).to eq 2

      expect(response).to redirect_to(edit_meth_methodology_path(id: methodology.id, step: step2.id))
    end
  end

  describe 'PATCH /step_down' do
    it 'moves down step_tool' do
      step1 = FactoryBot.create(:meth_step, name: 'step1', pos: 1, methodology: methodology)
      step2 = FactoryBot.create(:meth_step, name: 'step2', pos: 2, methodology: methodology)
      step3 = FactoryBot.create(:meth_step, name: 'step3', pos: 3, methodology: methodology)

      patch meth_step_down_path(id: step3.id)

      expect(step1.reload.pos).to eq 1
      expect(step2.reload.pos).to eq 3
      expect(step3.reload.pos).to eq 2

      expect(response).to redirect_to(edit_meth_methodology_path(id: methodology.id, step: step3.id))
    end
  end
end
